///**********************************************************************************************************************************
///  GCGradientPanel.h
///  GCDrawKit
///
///  Created by Jason on 03/25/07.
///  Released under the Creative Commons license 2006 Apptree.net.
///
/// 
///  This work is licensed under the Creative Commons Attribution-ShareAlike 2.5 License.
///  To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/2.5/ or send a letter to
///  Creative Commons, 543 Howard Street, 5th Floor, San Francisco, California, 94105, USA.
///
///**********************************************************************************************************************************

#import <Cocoa/Cocoa.h>

@class GCGradient;


@interface GCGradientPanel : NSWindowController

+ (GCGradientPanel*)	sharedGradientPanel;
+ (void)				setGradientPanelDefaultLibraryPath:(NSString*) path;

- (int)					version;

- (void)				setTarget:(id) aTarget;
- (void)				setAction:(SEL) anAction;
- (id)					target;
- (SEL)					action;

- (NSPanel*)			panel;

// gradients

- (void)				setGradient:(GCGradient*) grad;
- (GCGradient*)			gradient;

// current library

- (NSArray*)			gradientLibrary;
- (void)				setGradientLibrary:(NSArray*) lib addToExisting:(BOOL) merge;

- (NSDictionary*)		gradientLibraryPList;
- (void)				setGradientLibraryWithPList:(NSDictionary*) dict addToExisting:(BOOL) merge;

- (void)				loadGradientLibrary:(NSString*) filename merging:(BOOL) merge;
- (void)				writeGradientLibraryToFile:(NSString*) path atomically:(BOOL) atom;

// actions

- (IBAction)			show:(id) sender;
- (IBAction)			hide:(id) sender;
- (IBAction)			toggleDrawer:(id) sender;

- (IBAction)			saveLibrary:(id) sender;
- (IBAction)			loadLibrary:(id) sender;

@end


// informal protocol for simple receiving of gradient updates from the panel - any first responder
// that implements this will get the message. This is in addition to any explicit target/action you set.

@interface NSObject (GradientPanelClient)

- (void)				changeGradient:(id) sender;

@end
